import java.net.URL;
import java.net.MalformedURLException;
import java.util.Hashtable;
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.io.*;
import java.applet.Applet;

// Usada para mostrar la ventana que pregunta login

public class ventana extends Frame implements ActionListener, KeyListener, WindowListener {

  // Constantes
  private final int intentos = 3;  // Maximo numero de intentos

  // Variables
  private TextField name;              // Campo de login 
  private TextField psw;               // Campo de password
  private Button login;                // Boton de login 
  private Hashtable hash = null;       // Tabla hash con user passwd
  private int attempt = 0;             // Cuenta de los intentos
  private boolean valid = false;       // Flag de login valido
  private login app;                   // Applet pariente
  private URL pswfile;                 // Archivo de password
  private String user;
   
  public ventana(login parent, URL pswURL)
  {
    // Titulo de la ventana
    super("Curso OOP & D");
    app     = parent;
    pswfile = pswURL;

    // Color de fondo de la ventana
    setBackground(new Color(66,99,99));
 
    // Tipo de letra y tamao
    setFont(new Font("SansSerif", Font.PLAIN, 14));

    // Fijando el layout
    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints propiedades = new GridBagConstraints();
    setLayout(gridbag);    
    
    // Caracteristicas del campo Usuario
    propiedades.fill = GridBagConstraints.NONE;
    propiedades.anchor = GridBagConstraints.EAST;
    condiciones(propiedades, 0, 0, 1, 1, 10, 40);
    Label label1 = new Label("Usuario:", Label.LEFT);
    gridbag.setConstraints(label1, propiedades);
    add(label1);

    // Caracteristicas caja de texto para Nombre Usuario
    propiedades.fill = GridBagConstraints.HORIZONTAL;
    condiciones(propiedades, 1, 0, 1, 1, 90, 0);
    name = new TextField();
    gridbag.setConstraints(name, propiedades);
    name.addKeyListener(this);
    add(name);

    // Caracteristicas del campo Password
    propiedades.fill = GridBagConstraints.NONE;
    propiedades.anchor = GridBagConstraints.EAST;
    condiciones(propiedades, 0, 1, 1, 1, 0, 40);
    Label label2 = new Label("Password:", Label.LEFT);
    gridbag.setConstraints(label2, propiedades);
    add(label2);

    // Caracteristicas de caja de texto para Password
    propiedades.fill = GridBagConstraints.HORIZONTAL;
    condiciones(propiedades, 1, 1, 1, 1, 0, 0);
    psw = new TextField();
    psw.setEchoChar('*');
    gridbag.setConstraints(psw, propiedades);
    psw.addKeyListener(this);
    add(psw);

    // Panel de botones
    propiedades.fill = GridBagConstraints.NONE;
    propiedades.anchor = GridBagConstraints.CENTER;
        
    condiciones(propiedades, 0, 2, 2, 1, 0, 20);
    Panel panel = new Panel();
    
    // Condiciones del Panel
    panel.setLayout(new GridLayout(1, 2, 20, 2));
    gridbag.setConstraints(panel, propiedades);
    add(panel);
    
    // Boton de login
    login = new Button("Login");
    login.addActionListener(this);
    login.addKeyListener(this);
    login.setEnabled(false);
    panel.add(login);

    // Boton de cancel
    Button cancel = new Button("Cancel");
    cancel.addActionListener(this);
    cancel.addKeyListener(this);
    panel.add(cancel);

    // WindowListener
    addWindowListener(this);

    setSize(225,175);
    setResizable(false);

    // Posicion de la ventana
    Dimension d = getToolkit().getScreenSize();
    int x = Math.round( (d.width - 225) / 2 );
    int y = Math.round( (d.height - 175) / 2 );
    setLocation( new Point(x,y) );
    setVisible(true);

  } // ventana


void condiciones(GridBagConstraints gbc, int gx, int gy, int gw, int gh, int wx, int wy)
  {
    gbc.gridx = gx;
    gbc.gridy = gy;
    gbc.gridwidth = gw;
    gbc.gridheight = gh;
    gbc.weightx = wx;
    gbc.weighty = wy;
    gbc.ipadx = 0;
    gbc.ipady = 0;

  } 

// tamao de la ventana de texto  
public Insets getInsets() {
    return new Insets(20, 20, 20, 20);
  }
       

// Implementacion para el KeyListener
public void keyTyped(KeyEvent e) {
    return;  
  }
public void keyPressed(KeyEvent e) {
    return;
  }
public void keyReleased(KeyEvent e) {
    if (e.getSource() instanceof Button) {
      Button theSource = (Button) e.getSource();
      // Accion cuando se suelte el click
      if (e.getKeyCode() == KeyEvent.VK_ENTER) {
        ActionEvent ae = new ActionEvent(e.getSource(),ActionEvent.ACTION_PERFORMED,theSource.getActionCommand());
        theSource.dispatchEvent(ae);
      }
    }
    else {
      TextField theSource = (TextField) e.getSource();
      if (e.getKeyCode() == KeyEvent.VK_ENTER) {
        theSource.transferFocus();
      }
    }
  }

// Implementacion del WindowListener 
 
public void windowOpened(WindowEvent e) {
    if (Usuarios()) {
      login.setEnabled(true);
      name.requestFocus();
    }
    else {
      Mensaje msg = new Mensaje(this, "Error", "No encuentro el archivo de passwords!.");
      setVisible(false);
    }
  }
public void windowActivated(WindowEvent e) {
    return;
  }
public void windowDeactivated(WindowEvent e) {
    return;
  }
public void windowIconified(WindowEvent e) {
    setVisible(false);
  }
public void windowDeiconified(WindowEvent e) {
    return;
  }
public void windowClosing(WindowEvent e) {
    setVisible(false);
  }
public void windowClosed(WindowEvent e) {
    return;
  }

// Implementacion del ActionListener
public void actionPerformed(ActionEvent e) {

    Button theSource = (Button) e.getSource();
    if (theSource.getLabel().equals("Login")) {
      if (hash.containsKey(name.getText())) {
        String password = (String) hash.get(name.getText());
        String salt = name.getText().substring(0,2);
        if (password.equals(jcrypt.crypt(salt,psw.getText()))) {
          // Caso de Login correcto
          valid = true;
          setVisible(false);
user=name.getText();
        }
        else {
          Mensaje msg = new Mensaje(this, "Error", "Password equivocado. Intentalo denuevo!.");
          if (++attempt < intentos) {
            psw.requestFocus();
          }
          else {
            setVisible(false);
          }
        }
      }
      else {
        Mensaje msg = new Mensaje(this, "Error", "Nombre de usuario incorrecto. Intentalo denuevo!.");
        if (++attempt < intentos) {
          name.requestFocus();
        }
        else {
          setVisible(false);
        }
      }
    } else if (theSource.getLabel().equals("Cancel")) {
      setVisible(false);
    }
  }


// Carga de la lista de usuarios para verificar un login  
public boolean Usuarios() {
    try {
      System.out.println("Password file: "+ pswfile);
      BufferedReader in = new BufferedReader(new InputStreamReader(pswfile.openStream()));

      hash = new Hashtable(13);
      String inputLine;

      // leo el archivo de passwords y lo almaceno en una tabla hash
      while ((inputLine = in.readLine()) != null) {
        int i = inputLine.indexOf(' ');
        String username = inputLine.substring(0,i);
        i = inputLine.lastIndexOf(' ');
        String password = inputLine.substring(i+1);
        hash.put(username,password);
        System.out.println("username="+username+"\tpassword="+password);
      }
      in.close();
    }
    catch (Exception e) { 
      System.out.println(e); 
      return false; 
    }
    return true;
  } 
 
   public String Usuario()
     {
	return user;
     }
   
   
   
   
   
public boolean isValid() {
    return valid;
  } 
} 
